[mythtv-users] mac mini remote hack for ubuntu frontend

Brian Schott bschott at east.isi.edu
Fri May 4 19:32:53 UTC 2007


With the default Mythtv distribution for Ubuntu, all I was able to do  
with LIRC was change the volume. Trying to remap the remote keys  
under Mythtv failed with an "unknown key code" error message.

If anyone else is having trouble using the mac mini remote under  
Ubuntu Feisty, using the inputlirc package is MUCH easier than trying  
to configure LIRC.  Is this solution efficient? nope.  Cheesy? like a  
brick-o-velveeta!

I'm assuming you've installed and configured the ubuntu-mythv- 
frontend package (but it should work if the backend is installed as  
well).

1. Install inputlirc package:

% sudo aptitude install inputlirc

2. Edit /etc/default/inputlirc not conflict with lirc (I chose /dev/ 
inputlirc).  See my configuration file below.

3. Install the miniremoted perl script below in /usr/local/bin/.   
Make it executable.

% chmod a+x /usr/local/bin/miniremoted

4. Install the miniremoted start script below in /etc/init.d/. Make  
it executable.

% sudo chmod a+x /etc/init.d/miniremoted

5. Configure Mythtv front-end under Settings->General->General to use  
the telnet interface.

6. configure the daemon to start on boot, start the daemon

% sudo update-rc.d miniremoted defaults
% sudo invoke-rc.d miniremoted start

That should do it.

Brian

---------------------------------
==== /etc/default/inputlirc ====
---------------------------------
# Options to be passed to inputlirc.
EVENTS="/dev/input/event*"
OPTIONS="-d /dev/inputlirc"

---------------------------------
===== /usr/local/bin/miniremoted =====
---------------------------------
#!/usr/bin/perl

while (1)
{

# restart inputlirc daemon
     system ("/etc/init.d/inputlirc restart");

     # give daemon some time to start
     sleep 10;

# pull keycodes from lirc
# put them on local telnet port

     if (open (INBOUND, "irw /dev/inputlirc |"))
     {
         while (<INBOUND>)
         {
             system ("echo key down   | nc -q 0 localhost 6546") if (/ 
KEY_VOLUMEDOWN/);
             system ("echo key up     | nc -q 0 localhost 6546") if (/ 
KEY_VOLUMEUP/);
             system ("echo key right  | nc -q 0 localhost 6546") if (/ 
KEY_NEXTSONG/);
             system ("echo key left   | nc -q 0 localhost 6546") if (/ 
KEY_PREVIOUSSONG/);
             system ("echo key enter  | nc -q 0 localhost 6546") if (/ 
KEY_PLAYPAUSE/);
             system ("echo key escape | nc -q 0 localhost 6546") if (/ 
KEY_MENU/);
         }
     }
}

---------------------------------
====== /etc/init.d/miniremoted =====
---------------------------------

#! /bin/sh
### BEGIN INIT INFO
# Provides:          miniremoted
# Required-Start:    $local_fs $remote_fs
# Required-Stop:     $local_fs $remote_fs
# Default-Start:     2 3 4 5
# Default-Stop:      S 0 1 6
# Short-Description: Example initscript
# Description:       This file should be used to construct scripts to be
#                    placed in /etc/init.d.
### END INIT INFO

# Author: Foo Bar <foobar at baz.org>
#
# Please remove the "Author" lines above and replace them
# with your own name if you copy and modify this script.

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh  
script
PATH=/usr/sbin:/usr/bin:/sbin:/bin:/usr/local/bin
DESC="mini remote to mythtv"
NAME=miniremoted
DAEMON=/usr/local/bin/miniremoted
DAEMON_ARGS=""
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
[ -f /etc/default/rcS ] && . /etc/default/rcS

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
         # Return
         #   0 if daemon has been started
         #   1 if daemon was already running
         #   2 if daemon could not be started
         start-stop-daemon --start --background --quiet --pidfile  
$PIDFILE --exec $DAEMON --test > /dev/null \
                 || return 1
         start-stop-daemon --start --background --quiet --pidfile  
$PIDFILE --exec $DAEMON -- \
                 $DAEMON_ARGS \
                 || return 2
         # Add code here, if necessary, that waits for the process to  
be ready
         # to handle requests from services started subsequently  
which depend
         # on this one.  As a last resort, sleep for some time.
}


#
# Function that stops the daemon/service
#
do_stop()
{
         # Return
         #   0 if daemon has been stopped
         #   1 if daemon was already stopped
         #   2 if daemon could not be stopped
         #   other if a failure occurred
         start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 -- 
pidfile $PIDFILE --name $NAME
         RETVAL="$?"
         [ "$RETVAL" = 2 ] && return 2
         # Wait for children to finish too if this is a daemon that  
forks
         # and if the daemon is only ever run from this initscript.
         # If the above conditions are not satisfied then add some  
other code
         # that waits for the process to drop all resources that  
could be
         # needed by services started subsequently.  A last resort is to
         # sleep for some time.
         start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/ 
5 --exec $DAEMON
         [ "$?" = 2 ] && return 2
         # Many daemons don't delete their pidfiles when they exit.
         rm -f $PIDFILE
         return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
         #
         # If the daemon can reload its configuration without
         # restarting (for example, when it is sent a SIGHUP),
         # then implement that here.
         #
         start-stop-daemon --stop --signal 1 --quiet --pidfile  
$PIDFILE --name $NAME
         return 0
}

case "$1" in
   start)
         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
         do_start
         case "$?" in
                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
         esac
         ;;
   stop)
         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
         do_stop
         case "$?" in
                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
         esac
         ;;
   #reload|force-reload)
         #
         # If do_reload() is not implemented then leave this  
commented out
         # and leave 'force-reload' as an alias for 'restart'.
         #
         #log_daemon_msg "Reloading $DESC" "$NAME"
         #do_reload
         #log_end_msg $?
         #;;
   restart|force-reload)
         #
         # If the "reload" option is implemented then remove the
         # 'force-reload' alias
         #
         log_daemon_msg "Restarting $DESC" "$NAME"
         do_stop
         case "$?" in
           0|1)
                 do_start
                 case "$?" in
                         0) log_end_msg 0 ;;
                         1) log_end_msg 1 ;; # Old process is still  
running
                         *) log_end_msg 1 ;; # Failed to start
                 esac
                 ;;
           *)
                 # Failed to stop
                 log_end_msg 1
                 ;;
         esac
         ;;
   *)
         #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force- 
reload}" >&2
         echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
         exit 3
         ;;
esac

:




More information about the mythtv-users mailing list